﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.filters.BlurFilter;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Point;
	import flash.media.Video;
	import flash.media.Camera;
	
	public class Coliner extends Sprite
	{
		private var angle:Number = 0;
		private var vitesse:Number = 5;
		
		private var path:Array;
		private var pathHeight:Number;
		private var image:BitmapData;
		private var support:Sprite = new Sprite();
		private var filterObj:BlurFilter = new BlurFilter(4,4,10);//permet de faire disparaître particules
		
		private var myPicture:BitmapData;
		private var video:Video;
		
		private var colonne:Number;
		private var longueurTraits:Number = 5;
		private var grosseurTrait:Number = 20;
		
		public function Coliner()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void{
			colonne = stage.stageWidth/longueurTraits;
			video = new Video(stage.stageWidth, stage.stageHeight);
			image = new BitmapData(stage.stageWidth, stage.stageHeight,false,0);
			myPicture = new BitmapData(stage.stageWidth, stage.stageHeight,false,0)
			video.attachCamera( Camera.getCamera() );
			
			addChild (new Bitmap (image)) as Bitmap;
			
			this.addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function enterHandler(e:Event):void
		{
			myPicture.draw (video);
			image.lock();
			support.graphics.clear();
			support.graphics.moveTo(0,stage.stageHeight/2);
			for(var i:Number=0;i<colonne;i++){
				var posx:Number= (i+1)*longueurTraits;
				var posy:Number = Math.sin((i+1+angle)/colonne*Math.PI)*mouseY+stage.stageHeight/2;
				var lineS:Number = Math.sin((i+1)/colonne*Math.PI)*grosseurTrait;
				var pixelValue:uint = myPicture.getPixel(posx,posy);
				support.graphics.lineStyle(lineS,pixelValue);
				support.graphics.lineTo(posx,posy);
			}
			angle+=vitesse;
			image.applyFilter(image,image.rect,new Point(0,0),filterObj);
			image.draw(support);
			image.unlock();
		}
		
	}
}